<template>
  <div class="table-wrapper">
    <ColumnSwitcher :columns="columns" @toggle-column="$emit('toggle-column', $event)" />
    <div class="table">
      <div class="table-head">
        <div class="table-row">
          <div v-for="column in activeColumns" :key="column.id" class="table-head__cell">
            {{ column.title }}
          </div>
        </div>
      </div>
      
      <div v-if="(data.length || isDataLoading) && !!activeColumns.length" class="table-body">
        <TheSpinner v-if="isDataLoading" />
        <div
          v-for="dataItem in data"
          :key="dataItem.uniqueId"
          class="table-row"
        >
          <TableColumn
            v-for="col in activeColumns"
            :key="col.id"
            v-slot="{value}"
            class="table-body-cell"
            :column="col"
            :data-entry="dataItem"
          >
            <div v-if="!value" class="table-body-cell__value-empty">
              –
            </div>
            
            <Component
              :is="col.component"
              v-else-if="col.component"
              :value="value"
            />
            
            <div v-else class="table-body-cell__value">
              {{ value }}
            </div>
          </TableColumn>
        </div>
      </div>
      <div v-else class="table-empty">
        <div class="table-empty__title">
          Немає даних
        </div>
        <div class="table-empty__text">
          Оберіть 1 або більше комірок для показу або спробуйте пізніше
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>
import ColumnSwitcher from './components/ColumnSwitcher.vue'
import TableColumn from './components/TableColumn.vue'
import TheSpinner from '../common/TheSpinner.vue'
import { computed } from 'vue'

const props = defineProps({
  columns: {
    type: Array,
    default: () => []
  },
  data: {
    type: Array,
    default: () => []
  },
  isDataLoading: {
    type: Boolean,
    default: false
  }
})

defineEmits({
  'toggle-column': null
})

const activeColumns = computed(() => props.columns.filter(column => column.showColumn))
</script>

<style scoped>
.table {
  position: relative;
  width: 100%;
  
  &-head {
    overflow-x: auto;
    position: sticky;
    top: 0;
    border-bottom: 1px solid var(--main-dark);
    background-color: var(--main-white);
    
    &__cell {
      color: var(--main-dark);
      display: flex;
      align-items: center;
      justify-content: flex-start;
      padding: 8px 12px;
      font-weight: 700;
    }
  }
  
  &-body {
    overflow-x: auto;
    min-height: 400px;
    
    &-cell {
      display: flex;
      align-items: center;
      padding: 8px 12px;
      
      &__value {
      
      }
      
      &__value-empty {
        font-weight: 700;
      }
    }
    
    .table-row {
      background-color: var(--platinum);
      
      &:nth-child(2n) {
        background-color: var(--main-white);
      }
    }
  }
  
  &-empty {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    padding: 24px;
    
    &__title {
      font-size: 3rem;
      margin-bottom: 24px;
    }
    
    &__text {
    
    }
  }
  
  &-row {
    display: grid;
    grid-template-columns: repeat(auto-fit, minmax(100px, 1fr));
  }
}
</style>
